from openTSNE import TSNE
import pandas as pd
import pickle
import _pickle as cPickle
import bz2
from sklearn.feature_selection import VarianceThreshold
import hdbscan



def decompress_pickle(file):
    data = bz2.BZ2File(file, 'rb')
    data = cPickle.load(data)
    return data

def embedding_classifying(prefix, outfolder, outprediction, outprefix):

    sorted_filename = "sorted_" + outprefix + "_prediction.rtab"

    filepath = (outprediction + '/' + sorted_filename)

    query_presence_absence = pd.read_table(filepath)

    query_presence_absence = query_presence_absence.reset_index(drop=True)

    query_presence_absence = query_presence_absence.drop(['Unitig_sequence'], axis = 1)

    query_presence_absence = query_presence_absence.transpose()

    query_numpy_presence_absence = query_presence_absence.to_numpy()

    path_model = (outfolder + '/' + prefix + '_embedding.pbz2')

    embedding_train = decompress_pickle(path_model)

    embedding_query = embedding_train.transform(query_numpy_presence_absence)

    df_tsne_query = pd.DataFrame(embedding_query)

    path_hdbscan_model = (outfolder + '/' + prefix + '_clusters.pbz2')

    hdbscan_clusterer = decompress_pickle(path_hdbscan_model)

    query_labels, strenghts = hdbscan.approximate_predict(hdbscan_clusterer, df_tsne_query)

    labels_query_df = pd.DataFrame(query_labels)

    opentsne_query_info = pd.concat([df_tsne_query, labels_query_df, pd.DataFrame(query_presence_absence.index.values)], axis=1)

    opentsne_query_info = opentsne_query_info.reset_index(drop=True)

    opentsne_query_info.columns = ['tsne1D', 'tsne2D', 'Standard_Cluster','Sample_Name']


    path_results_model = (outprediction + '/' + outprefix + '_prediction.csv')


    opentsne_query_info.to_csv(path_results_model, index = False)
